/* FFT, DISCRETE-TIME SIGNAL PROCESSING, Oppenheim, pag. 608
   adaptaci del programa en FORTRAN
   diezmat en temps */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <graphics.h>

#define rnd() (rand() / (double) RAND_MAX)

typedef struct complex complex;
double pi;

int FFT(complex x[], unsigned n)
{
  complex t;
  int N, a, c, d, f, g, h, j, m, p, q, r, s, u, w, z;
  double b, e, k, l, co, si;

  N = pow(2, n);
  a = N; b = 2 * pi / N;
  for(c = 1; c <= n; c++)
   {
     d = a; a = a / 2; e = 0;
     for(f = 1; f <= a; f++)
      {
        co = cos(e); si = sin(e); e = e + b; u = 1;
        for(g = d; g <= N; g = u * d)
         {
           u++; h = g - d + f; j = h + a;
	   t.x = x[h].x - x[j].x; t.y = x[h].y - x[j].y;
	   x[h].x = x[h].x + x[j].x; x[h].y = x[h].y + x[j].y;
	   x[j].x = co * t.x + si * t.y; x[j].y = co * t.y - si * t.x;
         }
      }
     b = 2 * b;
   }

  m = 1;
  p = N / 2;
  q = N - 1;
  for(r = 1; r <= q; r++)
   {
     if(r > m - 1) goto label1;
     t = x[r];
     x[r] = x[m];
     x[m] = t;
label1: s = p;
label3: if(s > m - 1) goto label2;
     m = m - s;
     s = s / 2;
     goto label3;
label2: m = m + s;
   }

  return 1;
}

void main(void)
{
  complex *vector;
  int n, m;
  int gdriver = CGA, gmode = CGAHI;

  initgraph(&gdriver, &gmode, "");

  pi = 4 * atan(1.0);
  m = 257;
  vector = (complex *) malloc(m * sizeof(complex));

loop:
  m = 257;
  for(n = 1; n < m; n++)
   {
     vector[n].x = (sin(pi/4*n) + sin(pi/5*n) + rnd() / 3) *
		   (0.54 - 0.46 * cos(2*pi*(n-1)/256));
     vector[n].y = 0;
   }

  FFT(vector, 8);

  for(m = 0; m < 16384; *(int *)(0xb8000000L + m) = 0, m += 2);
  line(64, 190, 576, 190);
  moveto(64, 190);
  for(m = 1, n = 64; n < 576; n += 4, m++)
   lineto(n, 190 - (int) 5 * 10.0 * log10(cabs(vector[m])));

  if(!kbhit())
   goto loop;
}
